/*
 * API documentation
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 1.0.0-20181108155220-20181108155343
 * Contact: api.move@axa-assistance.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.insurance.bn.starter.model;

import com.google.gson.annotations.SerializedName;
import io.swagger.annotations.ApiModelProperty;
import org.threeten.bp.LocalDate;

import java.util.Objects;

/**
 * ApplianceCertificate
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2018-12-19T23:23:06.995+01:00")
public class ApplianceCertificate {
  @SerializedName("contract_holder")
  private ContractHolder contractHolder = null;

  @SerializedName("product_criteria")
  private Model32 productCriteria = null;

  @SerializedName("appliance_information")
  private ApplianceInformation applianceInformation = null;

  @SerializedName("extended_warranty_information")
  private ExtendedWarrantyInformation extendedWarrantyInformation = null;

  @SerializedName("beneficiaries")
  private Model33 beneficiaries = null;

  @SerializedName("certificate_id")
  private String certificateId = null;

  @SerializedName("certificate_type_name")
  private String certificateTypeName = null;

  @SerializedName("created_at")
  private LocalDate createdAt = null;

  public ApplianceCertificate contractHolder(ContractHolder contractHolder) {
    this.contractHolder = contractHolder;
    return this;
  }

   /**
   * Get contractHolder
   * @return contractHolder
  **/
  @ApiModelProperty(required = true, value = "")
  public ContractHolder getContractHolder() {
    return contractHolder;
  }

  public void setContractHolder(ContractHolder contractHolder) {
    this.contractHolder = contractHolder;
  }

  public ApplianceCertificate productCriteria(Model32 productCriteria) {
    this.productCriteria = productCriteria;
    return this;
  }

   /**
   * Get productCriteria
   * @return productCriteria
  **/
  @ApiModelProperty(required = true, value = "")
  public Model32 getProductCriteria() {
    return productCriteria;
  }

  public void setProductCriteria(Model32 productCriteria) {
    this.productCriteria = productCriteria;
  }

  public ApplianceCertificate applianceInformation(ApplianceInformation applianceInformation) {
    this.applianceInformation = applianceInformation;
    return this;
  }

   /**
   * Get applianceInformation
   * @return applianceInformation
  **/
  @ApiModelProperty(required = true, value = "")
  public ApplianceInformation getApplianceInformation() {
    return applianceInformation;
  }

  public void setApplianceInformation(ApplianceInformation applianceInformation) {
    this.applianceInformation = applianceInformation;
  }

  public ApplianceCertificate extendedWarrantyInformation(ExtendedWarrantyInformation extendedWarrantyInformation) {
    this.extendedWarrantyInformation = extendedWarrantyInformation;
    return this;
  }

   /**
   * Get extendedWarrantyInformation
   * @return extendedWarrantyInformation
  **/
  @ApiModelProperty(value = "")
  public ExtendedWarrantyInformation getExtendedWarrantyInformation() {
    return extendedWarrantyInformation;
  }

  public void setExtendedWarrantyInformation(ExtendedWarrantyInformation extendedWarrantyInformation) {
    this.extendedWarrantyInformation = extendedWarrantyInformation;
  }

  public ApplianceCertificate beneficiaries(Model33 beneficiaries) {
    this.beneficiaries = beneficiaries;
    return this;
  }

   /**
   * Get beneficiaries
   * @return beneficiaries
  **/
  @ApiModelProperty(required = true, value = "")
  public Model33 getBeneficiaries() {
    return beneficiaries;
  }

  public void setBeneficiaries(Model33 beneficiaries) {
    this.beneficiaries = beneficiaries;
  }

  public ApplianceCertificate certificateId(String certificateId) {
    this.certificateId = certificateId;
    return this;
  }

   /**
   * Certificate unique identifier
   * @return certificateId
  **/
  @ApiModelProperty(example = "1", required = true, value = "Certificate unique identifier")
  public String getCertificateId() {
    return certificateId;
  }

  public void setCertificateId(String certificateId) {
    this.certificateId = certificateId;
  }

  public ApplianceCertificate certificateTypeName(String certificateTypeName) {
    this.certificateTypeName = certificateTypeName;
    return this;
  }

   /**
   * Certificate type name
   * @return certificateTypeName
  **/
  @ApiModelProperty(example = "auto_rental", value = "Certificate type name")
  public String getCertificateTypeName() {
    return certificateTypeName;
  }

  public void setCertificateTypeName(String certificateTypeName) {
    this.certificateTypeName = certificateTypeName;
  }

  public ApplianceCertificate createdAt(LocalDate createdAt) {
    this.createdAt = createdAt;
    return this;
  }

   /**
   * Date when the certificate has been created  - ISO 8601 format (YYYY-MM-DD)
   * @return createdAt
  **/
  @ApiModelProperty(example = "2017-09-14", required = true, value = "Date when the certificate has been created  - ISO 8601 format (YYYY-MM-DD)")
  public LocalDate getCreatedAt() {
    return createdAt;
  }

  public void setCreatedAt(LocalDate createdAt) {
    this.createdAt = createdAt;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ApplianceCertificate applianceCertificate = (ApplianceCertificate) o;
    return Objects.equals(this.contractHolder, applianceCertificate.contractHolder) &&
        Objects.equals(this.productCriteria, applianceCertificate.productCriteria) &&
        Objects.equals(this.applianceInformation, applianceCertificate.applianceInformation) &&
        Objects.equals(this.extendedWarrantyInformation, applianceCertificate.extendedWarrantyInformation) &&
        Objects.equals(this.beneficiaries, applianceCertificate.beneficiaries) &&
        Objects.equals(this.certificateId, applianceCertificate.certificateId) &&
        Objects.equals(this.certificateTypeName, applianceCertificate.certificateTypeName) &&
        Objects.equals(this.createdAt, applianceCertificate.createdAt);
  }

  @Override
  public int hashCode() {
    return Objects.hash(contractHolder, productCriteria, applianceInformation, extendedWarrantyInformation, beneficiaries, certificateId, certificateTypeName, createdAt);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ApplianceCertificate {\n");
    
    sb.append("    contractHolder: ").append(toIndentedString(contractHolder)).append("\n");
    sb.append("    productCriteria: ").append(toIndentedString(productCriteria)).append("\n");
    sb.append("    applianceInformation: ").append(toIndentedString(applianceInformation)).append("\n");
    sb.append("    extendedWarrantyInformation: ").append(toIndentedString(extendedWarrantyInformation)).append("\n");
    sb.append("    beneficiaries: ").append(toIndentedString(beneficiaries)).append("\n");
    sb.append("    certificateId: ").append(toIndentedString(certificateId)).append("\n");
    sb.append("    certificateTypeName: ").append(toIndentedString(certificateTypeName)).append("\n");
    sb.append("    createdAt: ").append(toIndentedString(createdAt)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

